;;;Plz view Readme.txt for documentation of functions :)

;; Needs nagoa+.inc to assemble.

proc m_strlen,startpos
	push edi
	push ecx
	
	mov edi,[@startpos]
	mov ecx,-1
	mov al,0
	repne scasb
	not ecx
	dec ecx
	mov eax,ecx
	
	pop ecx
	pop edi
endproc

proc m_strcmp,string1,string2
	push esi
	push edi
		
	mov esi,[@string1]
	mov edi,[@string2]
	xor eax,eax
	whileand byte[esi],ne,0,byte[edi],ne,0
		lodsb
		if byte[edi],e,al
			inc edi
		else
			jmp m_strcmp_exit
		endif
	wend
	lodsb
m_strcmp_exit:
	sub al,byte[edi]
	pop edi
	pop esi
endproc

proc m_strncmp,string1,string2,count
	push esi
	push edi
	push ecx
	
	mov esi,[@string1]
	mov edi,[@string2]
	xor eax,eax
	mov ecx,[@count]
	whileand byte[esi],ne,0,byte[edi],ne,0
		if ecx,e,0
			mov al,0
			jmp near m_strncmp_popsavedreg
		endif
		lodsb
		if byte[edi],e,al
			dec ecx
			inc edi
		else
			jmp m_strncmp_exit
		endif
	wend
	lodsb
m_strncmp_exit:
	sub al,byte[edi]
m_strncmp_popsavedreg:
	pop ecx
	pop edi
	pop esi
endproc


proc m_strcmpi,string1,string2
	push esi
	push edi
	
	mov esi,[@string1]
	mov edi,[@string2]
	xor eax,eax
	whileand byte[esi],ne,0,byte[edi],ne,0
		lodsb
		or al,32
		or byte[edi],32
		if byte[edi],e,al
			inc edi
		else
			jmp m_strcmpi_exit
		endif
	wend
	lodsb
m_strcmpi_exit:
	sub al,byte[edi]
	
	pop edi
	pop esi
endproc


proc m_strncmpi,string1,string2,count
	push esi
	push edi
	push ecx
	
	mov esi,[@string1]
	mov edi,[@string2]
	xor eax,eax
	mov ecx,[@count]
	whileand byte[esi],ne,0,byte[edi],ne,0
		if ecx,e,0
			mov al,0
			jmp near m_strncmpi_popsavedreg
		endif
		lodsb
		or al,32
		or byte[edi],32
		if byte[edi],e,al
			dec ecx
			inc edi
		else
			jmp m_strncmpi_exit
		endif
	wend
	lodsb
m_strncmpi_exit:
	sub al,byte[edi]
m_strncmpi_popsavedreg:
	pop ecx
	pop edi
	pop esi
endproc



proc m_strcpy,src_string,dest_string
	pusha
	
	mov esi,[@src_string]
	mov edi,[@dest_string]
	mov al,1
	while al,ne,0
		lodsb
		stosb
	wend
	
	popa
endproc

proc m_strncpy,src_string,dest_string,count
	pusha 
	
	mov esi,[@src_string]
	mov edi,[@dest_string]
	mov ecx,[@count]
	repne movsb
	mov al,0
	stosb
	
	popa
endproc


proc m_strrev,src_string,dest_string
	pusha
	
	mov esi,[@src_string]
	xor ecx,ecx
	lodsb
	while al,ne,0
		push eax
		lodsb
		inc ecx
	wend
	mov edi,[@dest_string]
	while ecx,g,0
		pop eax
		stosb
		dec ecx
	wend
	mov al,0
	stosb
	popa
endproc

;proc m_maxof,num1,num2
;	push ebx
;	
;	mov eax,[@num1]
;	mov ebx,[@num2]
;	if eax,l,ebx
;		mov eax,ebx
;	endif
;	
;	pop ebx
;endproc 

;proc m_minof,num1,num2
;	push ebx
;	
;	mov eax,[@num1]
;	mov ebx,[@num2]
;	if eax,g,ebx
;		mov eax,ebx
;	endif
;	
;	pop ebx
;endproc 